// DISCLAIMER OF LIABILITY
// 
// This text/file contains proprietary, confidential
// information of Xilinx, Inc., is distributed under license
// from Xilinx, Inc., and may be used, copied and/or
// disclosed only pursuant to the terms of a valid license
// agreement with Xilinx, Inc. Xilinx hereby grants you a 
// license to use this text/file solely for design, simulation, 
// implementation and creation of design files limited 
// to Xilinx devices or technologies. Use with non-Xilinx 
// devices or technologies is expressly prohibited and 
// immediately terminates your license unless covered by
// a separate agreement.
//
// Xilinx is providing this design, code, or information 
// "as-is" solely for use in developing programs and 
// solutions for Xilinx devices, with no obligation on the 
// part of Xilinx to provide support. By providing this design, 
// code, or information as one possible implementation of 
// this feature, application or standard, Xilinx is making no 
// representation that this implementation is free from any 
// claims of infringement. You are responsible for 
// obtaining any rights you may require for your implementation. 
// Xilinx expressly disclaims any warranty whatsoever with 
// respect to the adequacy of the implementation, including 
// but not limited to any warranties or representations that this
// implementation is free from claims of infringement, implied 
// warranties of merchantability or fitness for a particular 
// purpose.
//
// Xilinx products are not intended for use in life support
// appliances, devices, or systems. Use in such applications is
// expressly prohibited.
//
// Any modifications that are made to the Source Code are 
// done at the users sole risk and will be unsupported.
//
//
// Copyright (c) 2007, 2008 Xilinx, Inc. All rights reserved.
//
// This copyright and support notice must be retained as part 
// of this text at all times. 
//
//******************************************************************************/
// Filename            : vsk_dvi_out.h
// $Revision:: 2237   $: Revision of last commit
// $Date:: 2008-05-09#$: Date of last commit
// Description         : VSK DVI output driver header file
//******************************************************************************/

#ifndef __vsk_dvi_out__
#define __vsk_dvi_out__
 
//#include "xenv.h"
#include "xparameters.h"
#include "xutil.h"
#include "vsk_iic.h"
#include "vsk_iic_devices.h"
#include "vsk_util.h"


#define MAX_IIC_DVI_OUT_MODES 2

#define MAX_IIC_DVI_OUT 8

// DVI OUT IIC Configuration Modes
#define IIC_DVI_OUT             0
#define IIC_DVI_OUT_640x480P60  0
#define IIC_DVI_OUT_720x576P50  0
#define IIC_DVI_OUT_720x480P60  0
#define IIC_DVI_OUT_800x600P60  0
#define IIC_DVI_OUT_1024x768P70 0
#define IIC_DVI_OUT_720P50      0
#define IIC_DVI_OUT_720P60      0
#define IIC_DVI_OUT_1080I50     1
#define IIC_DVI_OUT_1080I60     1
#define IIC_DVI_OUT_1080P25     1
#define IIC_DVI_OUT_1080P30     1
#define IIC_DVI_OUT_UTIA_ANA    0
#define IIC_DVI_OUT_UTIA_DIG    1

/******************************************************************************
* This function initializes the operating mode of the dvi_out port.
*
* @param    mode contains the selected mode that the dvi_out port is to be 
*           programmed.
*
* @return   None.
*
* @note     None.
*
******************************************************************************/
void vsk_dvi_out_config(Xint32 mode);


/***********************************************************************
* This function checks to see if a video display is connected to the 
* dvi_out port.
*
* @param    message specifies whether or not to print the warning message.
*             1 - print message
*             0 - do not print message
*
* @return   The result of the check 
*             2 - Analog Display Present
*             1 - Digital Display Present
*             0 - Display Not Present
*
* @note     None.
*
***********************************************************************/
Xint32 vsk_dvi_out_display_present(Xint32 message);
 
#endif
