// DISCLAIMER OF LIABILITY
// 
// This text/file contains proprietary, confidential
// information of Xilinx, Inc., is distributed under license
// from Xilinx, Inc., and may be used, copied and/or
// disclosed only pursuant to the terms of a valid license
// agreement with Xilinx, Inc. Xilinx hereby grants you a 
// license to use this text/file solely for design, simulation, 
// implementation and creation of design files limited 
// to Xilinx devices or technologies. Use with non-Xilinx 
// devices or technologies is expressly prohibited and 
// immediately terminates your license unless covered by
// a separate agreement.
//
// Xilinx is providing this design, code, or information 
// "as-is" solely for use in developing programs and 
// solutions for Xilinx devices, with no obligation on the 
// part of Xilinx to provide support. By providing this design, 
// code, or information as one possible implementation of 
// this feature, application or standard, Xilinx is making no 
// representation that this implementation is free from any 
// claims of infringement. You are responsible for 
// obtaining any rights you may require for your implementation. 
// Xilinx expressly disclaims any warranty whatsoever with 
// respect to the adequacy of the implementation, including 
// but not limited to any warranties or representations that this
// implementation is free from claims of infringement, implied 
// warranties of merchantability or fitness for a particular 
// purpose.
//
// Xilinx products are not intended for use in life support
// appliances, devices, or systems. Use in such applications is
// expressly prohibited.
//
// Any modifications that are made to the Source Code are 
// done at the users sole risk and will be unsupported.
//
//
// Copyright (c) 2007, 2008 Xilinx, Inc. All rights reserved.
//
// This copyright and support notice must be retained as part 
// of this text at all times. 
//
//******************************************************************************/
// Filename            : vsk_iic_devices.h
// $Revision:: 2239   $: Revision of last commit
// $Date:: 2008-05-09#$: Date of last commit
// Description         : IIC addresses for all VSK devices
//******************************************************************************/

#ifndef __vsk_iic_devices__
#define __vsk_iic_devices__
 
#define IIC_DVI_OUT_ADDR        0x76 // 0xEC/2
#define IIC_DVI_IN_ADDR         0x4D // 0x9A/2
#define IIC_IO_EXP_ADDR         0x20 // 0x40/2
#define IIC_SD_IN_ADDR          0x21 // 0x42/2
#define IIC_SD_OUT_ADDR         0x2A // 0x54/2
#define IIC_BASE_MUX_ADDR       0x72 // 0xE4/2
#define IIC_FMC_MUX_ADDR        0x74 // 0xE8/2
#define IIC_EPIX_CAMERA_ADDR    0x5C // 0xB8/2
#define IIC_IRVINE_CAMERA_ADDR  0x4C // 0x98/2
#define IIC_EDID_DVI_IN_ADDR    0x50 // 0xA0/2
#define IIC_EDID_DVI_OUT_ADDR   0x50 // 0xA0/2
#define IIC_FMC_POWER_ADDR      0x52 // 0xA4/2 // Rev D 
#define IIC_CLOCK_ADDR 		  	  0x6A // 0xD4/2

#endif
