#include "stdio_fp11.h"
#include "b_fp1101p0.h"

#define MAXNUM 20
unsigned char sieve[MAXNUM];
unsigned char i, j, m;
unsigned char ah, bh, zh, n, op, led, btn;

void main() {
	pb2dfu_set(C_PBP_REG01, 0);
	op = mb2pb_read_data();
	if (op == C_DFU_OP_VVER) {
		pb2dfu_set(C_DFU_CNT, 0);
		pb2dfu_set(C_DFU_OP, op);
		pb2dfu_wait4hw();
	} else {
		pb2dfu_set(C_DFU_A_MEM_ADDR, mb2pb_read_data());
		pb2dfu_set(C_DFU_A_MEM_SADDR, mb2pb_read_data());
		pb2dfu_set(C_DFU_B_MEM_ADDR, mb2pb_read_data());
		pb2dfu_set(C_DFU_B_MEM_SADDR, mb2pb_read_data());
		pb2dfu_set(C_DFU_Z_MEM_ADDR, mb2pb_read_data());
		pb2dfu_set(C_DFU_Z_MEM_SADDR, mb2pb_read_data());
		ah = mb2pb_read_data();
		pb2dfu_set(C_DFU_A_MEM_BANK, ah);
		bh = mb2pb_read_data();
		pb2dfu_set(C_DFU_B_MEM_BANK, bh);
		zh = mb2pb_read_data();
		pb2dfu_set(C_DFU_Z_MEM_BANK, zh);
		pb2dfu_set(C_DFU_A_INC, mb2pb_read_data());
		pb2dfu_set(C_DFU_B_INC, mb2pb_read_data());
		pb2dfu_set(C_DFU_Z_INC, mb2pb_read_data());
		n = mb2pb_read_data() - 1;
		pb2dfu_set(C_DFU_CNT, n);

		m = 4 * bh + zh + 5;

		pb2dfu_set(C_DFU_OP, op);
		{
			prime(sieve, m, i, j);
		}
		pb2dfu_wait4hw();

		pb2lcd_ascii_text();
		pb2lcd_ascii_char(hex_l(ah), C_LCD_01);
		pb2lcd_ascii_char(hex_l(bh), C_LCD_03);
		pb2lcd_ascii_char(hex_l(zh), C_LCD_05);
		led = led2pb();
		pb2lcd_ascii_char(hex_h(led), C_LCD_09);
		pb2lcd_ascii_char(hex_l(led), C_LCD_0A);
		btn = btn2pb();
		pb2lcd_ascii_char(hex_h(btn), C_LCD_0E);
		pb2lcd_ascii_char(hex_l(btn), C_LCD_0F);

		pb2mb_write(C_SCREEN_1);
		{
			pb2mb_write('\n');
			pb2mb_write(' ');
			pb2mb_write('L');
			pb2mb_write('=');
			pb2mb_write(hex_h(led));
			pb2mb_write(hex_l(led));
		}
		pb2mb_eoc(led);

		pb2mb_write(C_SCREEN_2);
		{
			pb2mb_write('\n');
			pb2mb_write(' ');
			pb2mb_write(hex_h(m));
			pb2mb_write(hex_l(m));
			pb2mb_write(':');
			for (i = 2; i < m; ++i) {
				if (sieve[i] == 0) {
					pb2mb_write(hex_h(i));
					pb2mb_write(hex_l(i));
					pb2mb_write(' ');
				}
			}
		}
		pb2mb_eoc(led);

		pb2mb_write(C_SCREEN_0);
		pb2mb_eoc(led);
	}
	pb2mb_eoc('.');
	pb2mb_req_reset('.');
	pb2mb_reset();
}

