///////////////////////////////////////////////////////////////-*-C-*-
//
// Copyright (c) 2010 Xilinx, Inc.  All rights reserved.
//
// Xilinx, Inc.  XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION
// "AS IS" AS  A COURTESY TO YOU.  BY PROVIDING  THIS DESIGN, CODE, OR
// INFORMATION  AS  ONE   POSSIBLE  IMPLEMENTATION  OF  THIS  FEATURE,
// APPLICATION OR  STANDARD, XILINX  IS MAKING NO  REPRESENTATION THAT
// THIS IMPLEMENTATION  IS FREE FROM  ANY CLAIMS OF  INFRINGEMENT, AND
// YOU ARE  RESPONSIBLE FOR OBTAINING  ANY RIGHTS YOU MAY  REQUIRE FOR
// YOUR  IMPLEMENTATION.   XILINX  EXPRESSLY  DISCLAIMS  ANY  WARRANTY
// WHATSOEVER  WITH RESPECT  TO  THE ADEQUACY  OF THE  IMPLEMENTATION,
// INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR REPRESENTATIONS THAT
// THIS IMPLEMENTATION  IS FREE  FROM CLAIMS OF  INFRINGEMENT, IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// 
//////////////////////////////////////////////////////////////////////

#include "bce_fp11_1x8_0_plbw.h"
#include "xparameters.h"
#include "xil_io.h"
#include "xcope.h"

inline xc_status_t xc_bce_fp11_1x8_0_plbw_create(xc_iface_t **iface, void *config_table)
{
    // set up iface
    *iface = (xc_iface_t *) config_table;

#ifdef XC_DEBUG
    BCE_FP11_1X8_0_PLBW_Config *_config_table = config_table;

    if (_config_table->xc_create == NULL) {
        print("config_table.xc_create == NULL\r\n");
        exit(1);
    }
#endif

    // does nothing
    return XC_SUCCESS;
}

inline xc_status_t xc_bce_fp11_1x8_0_plbw_release(xc_iface_t **iface) 
{
    // does nothing
    return XC_SUCCESS;
}

inline xc_status_t xc_bce_fp11_1x8_0_plbw_open(xc_iface_t *iface)
{
    // does nothing
    return XC_SUCCESS;
}

inline xc_status_t xc_bce_fp11_1x8_0_plbw_close(xc_iface_t *iface)
{
    // does nothing
    return XC_SUCCESS;
}

inline xc_status_t xc_bce_fp11_1x8_0_plbw_read(xc_iface_t *iface, xc_r_addr_t addr, uint32_t *value)
{
    *value = Xil_In32((uint32_t *) addr);
    return XC_SUCCESS;
}

inline xc_status_t xc_bce_fp11_1x8_0_plbw_write(xc_iface_t *iface, xc_w_addr_t addr, const uint32_t value)
{
    Xil_Out32((uint32_t *) addr, value);
    return XC_SUCCESS;
}

xc_status_t xc_bce_fp11_1x8_0_plbw_getshmem(xc_iface_t *iface, const char *name, void **shmem)
{
    BCE_FP11_1X8_0_PLBW_Config *_config_table = (BCE_FP11_1X8_0_PLBW_Config *) iface;

    if (strcmp("z8", name) == 0) {
        *shmem = (void *) & _config_table->z8;
    } else if (strcmp("b8", name) == 0) {
        *shmem = (void *) & _config_table->b8;
    } else if (strcmp("a8", name) == 0) {
        *shmem = (void *) & _config_table->a8;
    } else if (strcmp("z7", name) == 0) {
        *shmem = (void *) & _config_table->z7;
    } else if (strcmp("b7", name) == 0) {
        *shmem = (void *) & _config_table->b7;
    } else if (strcmp("a7", name) == 0) {
        *shmem = (void *) & _config_table->a7;
    } else if (strcmp("z6", name) == 0) {
        *shmem = (void *) & _config_table->z6;
    } else if (strcmp("b6", name) == 0) {
        *shmem = (void *) & _config_table->b6;
    } else if (strcmp("a6", name) == 0) {
        *shmem = (void *) & _config_table->a6;
    } else if (strcmp("z5", name) == 0) {
        *shmem = (void *) & _config_table->z5;
    } else if (strcmp("b5", name) == 0) {
        *shmem = (void *) & _config_table->b5;
    } else if (strcmp("a5", name) == 0) {
        *shmem = (void *) & _config_table->a5;
    } else if (strcmp("z4", name) == 0) {
        *shmem = (void *) & _config_table->z4;
    } else if (strcmp("b4", name) == 0) {
        *shmem = (void *) & _config_table->b4;
    } else if (strcmp("a4", name) == 0) {
        *shmem = (void *) & _config_table->a4;
    } else if (strcmp("z3", name) == 0) {
        *shmem = (void *) & _config_table->z3;
    } else if (strcmp("b3", name) == 0) {
        *shmem = (void *) & _config_table->b3;
    } else if (strcmp("a3", name) == 0) {
        *shmem = (void *) & _config_table->a3;
    } else if (strcmp("z2", name) == 0) {
        *shmem = (void *) & _config_table->z2;
    } else if (strcmp("b2", name) == 0) {
        *shmem = (void *) & _config_table->b2;
    } else if (strcmp("a2", name) == 0) {
        *shmem = (void *) & _config_table->a2;
    } else if (strcmp("z1", name) == 0) {
        *shmem = (void *) & _config_table->z1;
    } else if (strcmp("b1", name) == 0) {
        *shmem = (void *) & _config_table->b1;
    } else if (strcmp("a1", name) == 0) {
        *shmem = (void *) & _config_table->a1;
    } else if (strcmp("pb2mb", name) == 0) {
        *shmem = (void *) & _config_table->pb2mb;
    } else if (strcmp("p1", name) == 0) {
        *shmem = (void *) & _config_table->p1;
    } else if (strcmp("p0", name) == 0) {
        *shmem = (void *) & _config_table->p0;
    } else if (strcmp("mb2pb", name) == 0) {
        *shmem = (void *) & _config_table->mb2pb;
    }
    else { *shmem = NULL; return XC_FAILURE; }

    return XC_SUCCESS;
}
