// DISCLAIMER OF LIABILITY
// 
// This text/file contains proprietary, confidential
// information of Xilinx, Inc., is distributed under license
// from Xilinx, Inc., and may be used, copied and/or
// disclosed only pursuant to the terms of a valid license
// agreement with Xilinx, Inc. Xilinx hereby grants you a 
// license to use this text/file solely for design, simulation, 
// implementation and creation of design files limited 
// to Xilinx devices or technologies. Use with non-Xilinx 
// devices or technologies is expressly prohibited and 
// immediately terminates your license unless covered by
// a separate agreement.
//
// Xilinx is providing this design, code, or information 
// "as-is" solely for use in developing programs and 
// solutions for Xilinx devices, with no obligation on the 
// part of Xilinx to provide support. By providing this design, 
// code, or information as one possible implementation of 
// this feature, application or standard, Xilinx is making no 
// representation that this implementation is free from any 
// claims of infringement. You are responsible for 
// obtaining any rights you may require for your implementation. 
// Xilinx expressly disclaims any warranty whatsoever with 
// respect to the adequacy of the implementation, including 
// but not limited to any warranties or representations that this
// implementation is free from claims of infringement, implied 
// warranties of merchantability or fitness for a particular 
// purpose.
//
// Xilinx products are not intended for use in life support
// appliances, devices, or systems. Use in such applications is
// expressly prohibited.
//
// Any modifications that are made to the Source Code are 
// done at the users sole risk and will be unsupported.
//
//
// Copyright (c) 2007, 2008 Xilinx, Inc. All rights reserved.
//
// This copyright and support notice must be retained as part 
// of this text at all times. 
//
//******************************************************************************/
// Filename            : vsk_iic_clock.h
// $Revision:: 2183   $: Revision of last commit
// $Date:: 2008-05-05#$: Date of last commit
// Description         : Header file for IIC programmable clock driver.
//******************************************************************************/

#ifndef __vsk_iic_clock__
#define __vsk_iic_clock__


/* 
 * The following constant identifies how many unique clock configurations are 
 * supported by this module. Following this are the constants which define 
 * each of the supported clock modes.
 */
#define NUM_CLOCK_CONFIG 5
#define CLOCK_CONFIG_27000MHZ 0
#define CLOCK_CONFIG_25175MHZ 1
#define CLOCK_CONFIG_74250MHZ 2
#define CLOCK_CONFIG_40000MHZ 3
#define CLOCK_CONFIG_65000MHZ 4

/* 
 * These are the function prototypes for externally exposed functions in this module.
 */
XStatus vsk_iic_clock_test (void);
XStatus vsk_iic_clock_config (Xuint32);

#endif // __vsk_iic_clock__

