// DISCLAIMER OF LIABILITY
// 
// This text/file contains proprietary, confidential
// information of Xilinx, Inc., is distributed under license
// from Xilinx, Inc., and may be used, copied and/or
// disclosed only pursuant to the terms of a valid license
// agreement with Xilinx, Inc. Xilinx hereby grants you a 
// license to use this text/file solely for design, simulation, 
// implementation and creation of design files limited 
// to Xilinx devices or technologies. Use with non-Xilinx 
// devices or technologies is expressly prohibited and 
// immediately terminates your license unless covered by
// a separate agreement.
//
// Xilinx is providing this design, code, or information 
// "as-is" solely for use in developing programs and 
// solutions for Xilinx devices, with no obligation on the 
// part of Xilinx to provide support. By providing this design, 
// code, or information as one possible implementation of 
// this feature, application or standard, Xilinx is making no 
// representation that this implementation is free from any 
// claims of infringement. You are responsible for 
// obtaining any rights you may require for your implementation. 
// Xilinx expressly disclaims any warranty whatsoever with 
// respect to the adequacy of the implementation, including 
// but not limited to any warranties or representations that this
// implementation is free from claims of infringement, implied 
// warranties of merchantability or fitness for a particular 
// purpose.
//
// Xilinx products are not intended for use in life support
// appliances, devices, or systems. Use in such applications is
// expressly prohibited.
//
// Any modifications that are made to the Source Code are 
// done at the users sole risk and will be unsupported.
//
//
// Copyright (c) 2007, 2008 Xilinx, Inc. All rights reserved.
//
// This copyright and support notice must be retained as part 
// of this text at all times. 
//
//******************************************************************************/
// Filename            : vsk_fmc_video.h
// $Revision:: 2238   $: Revision of last commit
// $Date:: 2008-05-09#$: Date of last commit
// Description         : VSK FMC-Video card driver header file
//******************************************************************************/

#ifndef __vsk_fmc_video__
#define __vsk_fmc_video__
 
//#include "xenv.h"
#include "xparameters.h"

#include "vsk_iic.h"
#include "vsk_iic_devices.h"
#include "vsk_util.h"


/*****************************************************************************
* This function initializes the FMC Video Power Control IC.
*
* @param    None.
*
* @return   Returns '1' on success, '0' on failure.
*
* @note     None.
*
******************************************************************************/
Xuint8 vsk_fmc_power_init(void);


/*****************************************************************************
* This function resets the everything on the FMC Video card.
*
* @param    None.
*
* @return   Returns '1' on success, '0' on failure.
*
* @note     None.
*
******************************************************************************/
Xuint8 vsk_fmc_reset(void);

#endif
