#include "stdio_fp11.h"
#include "b_fp1101p0.h"

#define MAXNUM 20
unsigned char sieve[MAXNUM];
unsigned char i, j, m;
unsigned char ah, bh, zh, n, op, led, btn;

void main() {
	pb2dfu_set(C_PBP_REG01, 0);
	op = mb2pb_read_data();
	if (op == C_DFU_OP_VVER) {
		pb2dfu_set(C_DFU_CNT, 0);
		pb2dfu_set(C_DFU_OP, op);
		pb2dfu_wait4hw();
	} else {
		pb2dfu_set(C_DFU_A_MEM_ADDR, mb2pb_read_data());
		pb2dfu_set(C_DFU_A_MEM_SADDR, mb2pb_read_data());
		pb2dfu_set(C_DFU_B_MEM_ADDR, mb2pb_read_data());
		pb2dfu_set(C_DFU_B_MEM_SADDR, mb2pb_read_data());
		pb2dfu_set(C_DFU_Z_MEM_ADDR, mb2pb_read_data());
		pb2dfu_set(C_DFU_Z_MEM_SADDR, mb2pb_read_data());
		ah = mb2pb_read_data();
		pb2dfu_set(C_DFU_A_MEM_BANK, ah);
		bh = mb2pb_read_data();
		pb2dfu_set(C_DFU_B_MEM_BANK, bh);
		zh = mb2pb_read_data();
		pb2dfu_set(C_DFU_Z_MEM_BANK, zh);
		pb2dfu_set(C_DFU_A_INC, mb2pb_read_data());
		pb2dfu_set(C_DFU_B_INC, mb2pb_read_data());
		pb2dfu_set(C_DFU_Z_INC, mb2pb_read_data());
		n = mb2pb_read_data() - 1;
		pb2dfu_set(C_DFU_CNT, n);

		m = 4 * bh + zh + 5;

		pb2dfu_set(C_DFU_OP, op);
		{
			prime(sieve, m, i, j);
		}
		pb2dfu_wait4hw();

		led = led2pb();
		btn = btn2pb();
		pb2mb_write(C_SCREEN_1);
		{
			pb2mb_write('\n');
			pb2mb_write(' ');
			pb2mb_write('L');
			pb2mb_write('=');
			pb2mb_write(hex_h(led));
			pb2mb_write(hex_l(led));
		}
		pb2mb_eoc(led);
		pb2mb_write(C_SCREEN_2);
		{
			pb2mb_write('\r');
			pb2mb_write(' ');
			pb2mb_write(hex_h(m));
			pb2mb_write(hex_l(m));
			pb2mb_write(':');
			pb2mb_write(' ');
			for (i = 2; i < m; ++i) {
				if (sieve[i] == 0) {
					pb2mb_write(hex_h(i));
					pb2mb_write(hex_l(i));
					pb2mb_write(' ');
				}
			}
		}
		pb2mb_eoc(led);

		pb2mb_write(C_SCREEN_4);
		{
			pb2mb_write('\r');
			pb2mb_write(' ');
			pb2mb_write('a');
			pb2mb_write('h');
			pb2mb_write('=');
			pb2mb_write(hex_h(ah));
			pb2mb_write(hex_l(ah));
			pb2mb_write(' ');
			pb2mb_write('b');
			pb2mb_write('h');
			pb2mb_write('=');
			pb2mb_write(hex_h(bh));
			pb2mb_write(hex_l(bh));
			pb2mb_write(' ');
			pb2mb_write('z');
			pb2mb_write('h');
			pb2mb_write('=');
			pb2mb_write(hex_h(zh));
			pb2mb_write(hex_l(zh));
		}
		pb2mb_eoc(led);

		pb2mb_write(C_SCREEN_0);
		pb2mb_eoc(led);
	}
	pb2mb_eoc('.');
	pb2mb_req_reset('.');
	pb2mb_reset();
}

