/*
 * Copyright (c) 2008 Xilinx, Inc.  All rights reserved.
 *
 * Xilinx, Inc.
 * XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS" AS A
 * COURTESY TO YOU.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
 * ONE POSSIBLE   IMPLEMENTATION OF THIS FEATURE, APPLICATION OR
 * STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS IMPLEMENTATION
 * IS FREE FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE RESPONSIBLE
 * FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE FOR YOUR IMPLEMENTATION.
 * XILINX EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH RESPECT TO
 * THE ADEQUACY OF THE IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO
 * ANY WARRANTIES OR REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE
 * FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "mfs_config.h"

int platform_init_fs()
{
    extern char _binary_image_mfs_start, _binary_image_mfs_size;

    /* initialize the memory file system (MFS) image pre-loaded into memory */
    xil_printf("Initializing MFS at 0x%08x\n\r", &_binary_image_mfs_start);
    mfs_init_fs((int)&_binary_image_mfs_size,
                (char *)(&_binary_image_mfs_start + 4),
                MFSINIT_IMAGE);

    xil_printf("Done.\n\r");

    /* check if we can access index.html */
    if (mfs_exists_file("index.html") == 0) {
        xil_printf("%s: ERROR: unable to locate index.html in MFS\n\r", __FUNCTION__);
        xil_printf("One of your applications requires a Memory File System to be loaded.\n\r");
        xil_printf("Please check if Memory File System has been loaded,\n\r"
                   "and it has index.html file in root directory\n\r");
        return -1;
    }

    xil_printf("Located index.html\n\r");

    return 0;
}

