//////////////////////////////////////////////////////////////////////////
//
//  Copyright (c) 2014 UTIA AV CR v.v.i. All rights reserved.
//
// UTIA IS PROVIDING THIS CODE, "AS IS" AS A COURTESY TO YOU.
// BY PROVIDING THIS CODE, AS ONE POSSIBLE IMPLEMENTATION,
// UTIA IS MAKING NO REPRESENTATION THAT THIS IMPLEMENTATION
// IS FREE FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE RESPONSIBLE
// FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE FOR YOUR IMPLEMENTATION.
// UTIA EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH RESPECT TO
// THE ADEQUACY OF THE IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO
// ANY WARRANTIES OR REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE
// FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY
// AND FITNESS FOR A PARTICULAR PURPOSE.
//
//////////////////////////////////////////////////////////////////////////


#ifndef UTIASPEDK_RGB565_CHAR
#define UTIASPEDK_RGB565_CHAR

#include "platform_config.h"

#ifdef UTIASPEDK_FPGA_3S1600E
#define UTIASPEDK_FPGA_TXT "FPGA 3s1600e-4  "
#endif

#ifdef UTIASPEDK_FPGA_3S700AN
#define UTIASPEDK_FPGA_TXT "FPGA 3s700an-4  "
#endif

#ifdef UTIASPEDK_FPGA_3SD1800A
#define UTIASPEDK_FPGA_TXT "FPGA 3sd1800a-4 "
#endif

#ifdef UTIASPEDK_FPGA_6SLX16
#define UTIASPEDK_FPGA_TXT "FPGA 6slx16-2es "
#endif

#ifdef UTIASPEDK_FPGA_6SLX45T
#define UTIASPEDK_FPGA_TXT "FPGA 6slx45t-3es"
#endif

// default
#ifndef UTIASPEDK_FPGA_TXT
#define UTIASPEDK_FPGA_TXT "FPGA Xilinx     "
#endif

#define VRAM_ADDR1 (UTIASPEDK_FRAME_BUFFER_BASE_ADDR)

#define RGB565_CHAR_WIDTH 8
#define RGB565_CHAR_HEIGHT 12
#define RGB565_PIXEL_BITS 32

#ifdef UTIASPEDK_RGB565_XGA75_1920_1080I_60HZ
#define UTIASPEDK_RGB565_XGA_TXT " UTIA EdkDSP Platform - Screen Support rgb888 1920x1080i V:60 Hz"
#define RGB565_X 1920
#define RGB565_Y 1080
#endif

#ifdef UTIASPEDK_RGB565_XGA65_1024_768_60HZ
#define UTIASPEDK_RGB565_XGA_TXT " UTIA EdkDSP Platform - Screen Support rgb888 1024x768 V:60 Hz H:48 kHz clock 65 MHz"
#define RGB565_X 1024
#define RGB565_Y  768
#endif

#ifdef UTIASPEDK_RGB565_XGA75_1024_768_70HZ
#define UTIASPEDK_RGB565_XGA_TXT " UTIA EdkDSP Platform - Screen Support rgb888 1024x768 V:70 Hz H:56 kHz clock 75 MHz"
#define RGB565_X 1024
#define RGB565_Y  768
#endif

#ifdef UTIASPEDK_RGB565_XGA75_1280_720_60HZ
#define UTIASPEDK_RGB565_XGA_TXT " UTIA EdkDSP Platform - Screen Support rgb888 1280x720 V:60 Hz H:60 kHz clock 75 MHz"
#define RGB565_X 1280
#define RGB565_Y  720 
#endif

#ifdef UTIASPEDK_RGB565_XGA80_1024_768_75HZ
#define UTIASPEDK_RGB565_XGA_TXT " UTIA EdkDSP Platform - Screen Support rgb888 1024x768 V:75 Hz H:60 kHz clock 80 MHz"
#define RGB565_X 1024
#define RGB565_Y  768
#endif

#ifdef UTIASPEDK_RGB565_XGA80_1152_864_60HZ
#define UTIASPEDK_RGB565_XGA_TXT " UTIA EdkDSP Platform - Screen Support rgb888 1152x864 V:60 Hz H:54 kHz clock 80 MHz"
#define RGB565_X 1152
#define RGB565_Y  864
#endif

#ifdef UTIASPEDK_RGB565_XGA108_1280_960_60HZ
#define UTIASPEDK_RGB565_XGA_TXT " UTIA EdkDSP Platform - Screen Support rgb888 1280x960 V:60 Hz H:60 kHz clock 108 MHz"
#define RGB565_X 1280
#define RGB565_Y  960 
#endif

#ifdef UTIASPEDK_RGB565_XGA108_1280_1020_60HZ
#define UTIASPEDK_RGB565_XGA_TXT " UTIA EdkDSP Platform - Screen Support rgb888 1280x1020 V:60 Hz H:64 kHz clock 108 MHz"
#define RGB565_X 1280
#define RGB565_Y 1020 
#endif

#ifdef UTIASPEDK_RGB565_XGA108_1280_1024_60HZ
#define UTIASPEDK_RGB565_XGA_TXT " UTIA EdkDSP Platform - Screen Support rgb888 1280x1024 V:60 Hz H:64 kHz clock 108 MHz"
#define RGB565_X 1280
#define RGB565_Y 1024 
#endif

#ifdef UTIASPEDK_RGB565_XGA83_1280_792_60HZ
#define UTIASPEDK_RGB565_XGA_TXT " UTIA EdkDSP Platform - Screen Support rgb888 1280x792 V:60 Hz H:49 kHz clock 83 MHz"
#define RGB565_X 1280
#define RGB565_Y  792
#endif

#ifdef UTIASPEDK_RGB565_XGA83_1280_800_60HZ
#define UTIASPEDK_RGB565_XGA_TXT " UTIA EdkDSP Platform - Screen Support rgb888 1280x800 V:60 Hz H:49 kHz clock 83 MHz"
#define RGB565_X 1280
#define RGB565_Y  800
#endif

#ifdef UTIASPEDK_RGB565_XGA83_1280_804_60HZ
#define UTIASPEDK_RGB565_XGA_TXT " UTIA EdkDSP Platform - Screen Support rgb888 1280x804 V:60 Hz H:49 kHz clock 83 MHz"
#define RGB565_X 1280
#define RGB565_Y  804
#endif

#ifdef UTIASPEDK_RGB565_XGA85_1360_768_60HZ
#define UTIASPEDK_RGB565_XGA_TXT " UTIA EdkDSP Platform - Screen Support rgb888 1360x768 V:60 Hz H:47,7 kHz clock 85 MHz"
#define RGB565_X 1360
#define RGB565_Y  768
#endif

#ifdef UTIASPEDK_RGB565_XGA106_1440_900_60HZ
#define UTIASPEDK_RGB565_XGA_TXT " UTIA EdkDSP Platform - Screen Support rgb888 1440x900 V:60 Hz H:56 kHz"
#define RGB565_X 1440
#define RGB565_Y  900
#endif

// default
#ifndef RGB565_X
#define UTIASPEDK_RGB565_XGA75_1024_768_70HZ
#define UTIASPEDK_RGB565_XGA_TXT " UTIA EdkDSP Platform - Screen Support rgb888 1024x768 V:70 Hz H:56 kHz clock 75 MHz"
#define RGB565_X 1024
#define RGB565_Y  768
#endif

typedef unsigned int pixel_t;

#define RGB565_00_00_00 ((pixel_t) (  0 << 8 |   0 << 16 |   0 << 24 )) // black
#define RGB565_03_07_03 ((pixel_t) ( 20 << 8 |  20 << 16 |  20 << 24 )) // white  10%
#define RGB565_05_11_05 ((pixel_t) ( 40 << 8 |  40 << 16 |  40 << 24 )) // white  15%
#define RGB565_07_15_07 ((pixel_t) ( 60 << 8 |  60 << 16 |  60 << 24 )) // white  20%
#define RGB565_08_16_08 ((pixel_t) ( 64 << 8 |  64 << 16 |  64 << 24 )) // white  25%
#define RGB565_15_31_15 ((pixel_t) (126 << 8 | 126 << 16 | 126 << 24 )) // white  49%
#define RGB565_16_32_16 ((pixel_t) (128 << 8 | 128 << 16 | 128 << 24 )) // white  51%
#define RGB565_31_63_31 ((pixel_t) (255 << 8 | 255 << 16 | 255 << 24 )) // white 100%
#define RGB565_03_00_00 ((pixel_t) ( 20 << 8 |  0 << 16 |  0 << 24 )) // red    10%
#define RGB565_07_00_00 ((pixel_t) ( 60 << 8 |  0 << 16 |  0 << 24 )) // red    20%
#define RGB565_15_00_00 ((pixel_t) (126 << 8 |  0 << 16 |  0 << 24 )) // red    49%
#define RGB565_16_00_00 ((pixel_t) (128 << 8 |  0 << 16 |  0 << 24 )) // red    51%
#define RGB565_31_00_00 ((pixel_t) (255 << 8 |  0 << 16 |  0 << 24 )) // red   100%
#define RGB565_00_07_00 ((pixel_t) ( 0 << 8 |  20 << 16 |  0 << 24 )) // green  10%
#define RGB565_00_15_00 ((pixel_t) ( 0 << 8 |  60 << 16 |  0 << 24 )) // green  20%
#define RGB565_00_31_00 ((pixel_t) ( 0 << 8 | 126 << 16 |  0 << 24 )) // green  49%
#define RGB565_00_32_00 ((pixel_t) ( 0 << 8 | 128 << 16 |  0 << 24 )) // green  51%
#define RGB565_00_63_00 ((pixel_t) ( 0 << 8 | 255 << 16 |  0 << 24 )) // green 100%
#define RGB565_00_00_03 ((pixel_t) ( 0 << 8 |  0 << 16 |  20 << 24 )) // blue   10%
#define RGB565_00_00_07 ((pixel_t) ( 0 << 8 |  0 << 16 |  60 << 24 )) // blue   20%
#define RGB565_00_00_15 ((pixel_t) ( 0 << 8 |  0 << 16 | 126 << 24 )) // blue   49%
#define RGB565_00_00_16 ((pixel_t) ( 0 << 8 |  0 << 16 | 128 << 24 )) // blue   51%
#define RGB565_00_00_31 ((pixel_t) ( 0 << 8 |  0 << 16 | 255 << 24 )) // blue  100%
typedef struct {
	int w, h;
	void *dat;
	unsigned char * line[RGB565_Y];
} RGB565_BITMAP;

typedef struct {
	unsigned int X;
	unsigned int Y;
	unsigned int XMIN;
	unsigned int YMIN;
	unsigned int XMAX;
	unsigned int YMAX;
	pixel_t FgColor;
	pixel_t BgColor;
} RGB565_CHAR;

RGB565_BITMAP *create_bitmap(int color_depth, int width, int height);
RGB565_BITMAP *create_screen(void *vram_ptr, int color_depth, int width,
		int height);

void RGB565_BITMAP_Initialize(RGB565_BITMAP *bmp, void *vram_ptr, int width,
		int height);

void RGB565_CHAR_Initialize(RGB565_BITMAP *bmp, RGB565_CHAR *InstancePtr,
		unsigned int x, unsigned int y, unsigned int xmin, unsigned int ymin,
		unsigned int xmax, unsigned int ymax, pixel_t FgCol, pixel_t BgCol);
void putpixel(RGB565_BITMAP *bmp, int x, int y, pixel_t color);
void hline(RGB565_BITMAP *bmp, int x1, int y1, int x2, pixel_t color);
void vline(RGB565_BITMAP *bmp, int x, int y1, int y2, pixel_t color);
void rect(RGB565_BITMAP *bmp, int x1, int y1, int x2, int y2, pixel_t color);
void fill_bmp(RGB565_BITMAP *bmp, pixel_t color);
void
		rectfill(RGB565_BITMAP *bmp, int x1, int y1, int x2, int y2,
				pixel_t color);
void do_line(RGB565_BITMAP *bmp, int x1, int y1, int x2, int y2, int d,
		void(*proc)(RGB565_BITMAP *, int, int, pixel_t));
void line(RGB565_BITMAP *bmp, int x1, int y1, int x2, int y2, pixel_t color);
void do_circle(RGB565_BITMAP *bmp, int x, int y, int radius, int d,
		void(*proc)(RGB565_BITMAP *, int, int, pixel_t));
void circle(RGB565_BITMAP *bmp, int x, int y, int radius, pixel_t color);
void circlefill(RGB565_BITMAP *bmp, int x, int y, int radius, pixel_t color);
void do_ellipse(RGB565_BITMAP *bmp, int x, int y, int rx, int ry, int d,
		void(*proc)(RGB565_BITMAP *, int, int, pixel_t));
void ellipse(RGB565_BITMAP *bmp, int x, int y, int rx, int ry, pixel_t color);
void ellipsefill(RGB565_BITMAP *bmp, int x, int y, int rx, int ry,
		pixel_t color);

void RGB565_CHAR_Border(RGB565_BITMAP *bmp, RGB565_CHAR *InstancePtr);
void RGB565_CHAR_LogoUTIA(RGB565_BITMAP *bmp, RGB565_CHAR *InstancePtr);
void RGB565_CHAR_SetPos(RGB565_BITMAP *bmp, RGB565_CHAR *InstancePtr,
		unsigned int x, unsigned int y);
void RGB565_CHAR_SetColor(RGB565_CHAR *InstancePtr, unsigned int fgCol,
		unsigned int bgCol);
void RGB565_CHAR_Clear(RGB565_BITMAP *bmp, RGB565_CHAR *InstancePtr);
void RGB565_CHAR_WriteChar(RGB565_BITMAP *bmp, unsigned char ch,
		unsigned int xu, unsigned int yu, pixel_t fgColor, pixel_t bgColor);
void RGB565_CHAR_Write(RGB565_BITMAP *bmp, RGB565_CHAR *InstancePtr,
		unsigned char ch);
void RGB565_CHAR_WriteString(RGB565_BITMAP *bmp, RGB565_CHAR *InstancePtr,
		const char *ch);
void RGB565_CHAR_WriteColor(RGB565_BITMAP *bmp, RGB565_CHAR *InstancePtr,
		unsigned char ch, pixel_t fgCol, pixel_t bgCol);
void RGB565_CHAR_WriteColorString(RGB565_BITMAP *bmp, RGB565_CHAR *InstancePtr,
		const char *ch, pixel_t fgCol, pixel_t bgCol);

#endif
